Public Class Form1
    Inherits System.Windows.Forms.Form
    Friend WithEvents btnExecute As System.Windows.Forms.Button
    Friend WithEvents txtQuery As System.Windows.Forms.TextBox

    Dim DatabaseMgr As New iAnywhere.UltraLite.DatabaseManager
    Dim Connection As iAnywhere.UltraLite.Connection

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lstResults As System.Windows.Forms.ListBox
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents InputPanel1 As Microsoft.WindowsCE.Forms.InputPanel
    Private Sub InitializeComponent()
        Me.btnExecute = New System.Windows.Forms.Button
        Me.txtQuery = New System.Windows.Forms.TextBox
        Me.lstResults = New System.Windows.Forms.ListBox
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.InputPanel1 = New Microsoft.WindowsCE.Forms.InputPanel
        '
        'btnExecute
        '
        Me.btnExecute.Location = New System.Drawing.Point(0, 48)
        Me.btnExecute.Size = New System.Drawing.Size(240, 20)
        Me.btnExecute.Text = "Execute SQL"
        '
        'txtQuery
        '
        Me.txtQuery.Multiline = True
        Me.txtQuery.Size = New System.Drawing.Size(240, 48)
        Me.txtQuery.Text = "select cust_id, cust_name from ULCustomer order by cust_id"
        '
        'lstResults
        '
        Me.lstResults.Location = New System.Drawing.Point(0, 72)
        Me.lstResults.Size = New System.Drawing.Size(240, 198)
        '
        'Form1
        '
        Me.Controls.Add(Me.lstResults)
        Me.Controls.Add(Me.txtQuery)
        Me.Controls.Add(Me.btnExecute)
        Me.Menu = Me.MainMenu1
        Me.MinimizeBox = False
        Me.Text = "Dynamic SQL - ULISQL"

    End Sub

#End Region

    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim prepared_statement As iAnywhere.UltraLite.PreparedStatement
        Dim result_set As iAnywhere.UltraLite.ResultSet

        Dim col_counter As Integer
        Dim result_string As String
        Dim row_count As Long

        ' Clear the data from the last executed statement
        lstResults.Items.Clear()

        Try
            ' Prepare the query
            prepared_statement = Connection.PrepareStatement(txtQuery.Text)

            If prepared_statement.HasResultSet Then
                ' This is a query, execute it
                result_set = prepared_statement.ExecuteQuery
            Else
                ' This is a non-query (insert/update/delete statement)
                row_count = prepared_statement.ExecuteStatement()

                MessageBox.Show(row_count + " rows updated.")
                Return  ' there is no result set
            End If
        Catch ex As iAnywhere.UltraLite.SQLException
            ' There was some sort of error with the SQL statement
            MessageBox.Show("SQL Error: " + ex.Message)
            Return
        End Try

        ' Iterate through the result set and display the rows
        While (result_set.MoveNext)
            result_string = ""
            For col_counter = 1 To result_set.Schema.ColumnCount
                If result_string = "" Then
                    result_string = Trim(result_set.GetString(col_counter))
                Else
                    result_string = result_string + ", " + Trim(result_set.GetString(col_counter))
                End If
            Next
            lstResults.Items.Add(result_string)

        End While
        result_set.Close()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim create_parms As New iAnywhere.UltraLite.CreateParms
        Dim app_path As String

        ' Set the database parameters.  We don't specify a schema file since a database
        ' has already been provided
        app_path = "\Program Files\ULISQL\"
        With create_parms
            .DatabaseOnCE = app_path + "ul_custdb.udb"
            .ConnectionName = "ul_custdb"
            .UserID = "dba"
            .Password = "sql"
        End With

        On Error Resume Next

        ' Connect to our database
        Connection = DatabaseMgr.OpenConnection(create_parms)

        ' Check to make sure the connection was opened
        If (Connection.IsOpen = False) Then
            MsgBox("Connection could not be opened.")
        End If

    End Sub

    Private Sub txtQuery_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtQuery.GotFocus
        InputPanel1.Enabled = True
    End Sub

    Private Sub txtQuery_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtQuery.LostFocus
        InputPanel1.Enabled = False
    End Sub
End Class
